
#ifndef KECHO
#define KECHO
#endif

#include "config.h"
#include "../../include/io.h"
#include "../../include/atl.h"
#include "../../include/cm.h"
#include "../../include/echo.h"
#include "../../include/comm_group2.h"

#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#define APP_NAME "USER1"
#define GRP_TYPE "USER1"

void handler(void *event, int length, void *client_data, attr_list event_attrs)
{
    printf("Event read\n");
    if (event_attrs != NULL) printf("Attributes received\n");
}

int main(int argc, char *argv[])
{
    EChannel uchan;
    CManager ucm;
    EControlContext ucc;
    ECSinkHandle shandle;
    int i;
    comm_group_return groups;

printf("phase1\n");
    ucm = CManager_create();
printf("phase2\n");
    ucc = ECho_CM_init(ucm);

printf("phase3\n");
    groups = matching_comm_groups(APP_NAME, GRP_TYPE);

printf("phase5\n");
    uchan = EChannel_open(ucc, groups->list[0].info);

printf("phase6a\n");
//    uhandle = ECsource_subscribe(uchan);

printf("phase6\n");
    shandle = ECsink_subscribe(uchan, handler, NULL);

    for (i = 0; i < 15; i++) {
printf("poll(%d)\n", i);
	CMpoll_network(ucm);
//ECsubmit_event(uhandle, &b, sizeof(long));
	sleep(2);
    }

    printf("reader done...\n"); 
    return 1;
}

