/* A Bison parser, made from ecl.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	LPAREN	257
# define	RPAREN	258
# define	LCURLY	259
# define	RCURLY	260
# define	LBRACKET	261
# define	RBRACKET	262
# define	DOT	263
# define	STAR	264
# define	SLASH	265
# define	MODULUS	266
# define	PLUS	267
# define	MINUS	268
# define	LEQ	269
# define	LT	270
# define	GEQ	271
# define	GT	272
# define	EQ	273
# define	NEQ	274
# define	LEFT_SHIFT	275
# define	RIGHT_SHIFT	276
# define	ASSIGN	277
# define	LOG_OR	278
# define	LOG_AND	279
# define	ARITH_OR	280
# define	ARITH_AND	281
# define	ARITH_XOR	282
# define	BANG	283
# define	SEMI	284
# define	IF	285
# define	ELSE	286
# define	FOR	287
# define	CHAR	288
# define	SHORT	289
# define	INT	290
# define	LONG	291
# define	UNSIGNED	292
# define	SIGNED	293
# define	FLOAT	294
# define	DOUBLE	295
# define	VOID	296
# define	STRING	297
# define	STATIC	298
# define	RETURN_TOKEN	299
# define	PRINT	300
# define	COMMA	301
# define	DOTDOTDOT	302
# define	integer_constant	303
# define	string_constant	304
# define	floating_constant	305
# define	identifier_ref	306
# define	type_id	307

#line 1 "ecl.y"

#ifdef MODULE
#ifndef __KERNEL__
#define __KERNEL__
#endif
#include <linux/kernel.h>
#include <linux/module.h>
#endif
#include "config.h"
#include "ecl.h"
#include "ecl_internal.h"
#include "assert.h"
#ifndef MODULE
#include <ctype.h>
#include <malloc.h>
#include <string.h>
#else
#include <linux/ctype.h>
#include <linux/string.h>
#include <linux/mm.h>
#endif
#include "structs.h"
#ifdef HAVE_DRISC_H
#include "../drisc/drisc.h"
#else
#ifdef HAVE_ICODE_H
#include "drisc_icode.h"
#include "icode.h"
#else
enum {
    DR_C,    /* char */
    DR_UC,   /* unsigned char */
    DR_S,    /* short */
    DR_US,   /* unsigned short */
    DR_I,    /* int */
    DR_U,    /* unsigned */
    DR_L,    /* long */
    DR_UL,   /* unsigned long */
    DR_P,    /* pointer */
    DR_F,    /* floating */
    DR_D,    /* double */
    DR_V,    /* void */
    DR_B,    /* block structure */
    DR_ERR   /* no type */
};
#endif
#endif
#ifndef MODULE
#ifdef STDC_HEADERS
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#else
#include "kecl.h"
#define malloc (void *)DAllocMM
#define free(a) DFreeMM((addrs_t)a)
#define realloc(a,b) DReallocMM((addrs_t)a,b)
#define fprintf(fmt, args...) printk(args);
#define printf printk
char *strdup(const char *s)
{
	char *p;

	p = (char *)kmalloc(strlen(s)+1, GFP_KERNEL);
	if (p != NULL)
		strcpy(p,s);
	return p;
}
#endif
static char *create_string_from_yytext();
extern int yyparse();
static sm_ref yyparse_value;
static int yyerror_count = 1;
extern void yyerror(char *str);
static int parsing_type = 0;
static ecl_parse_context yycontext;

#line 80 "ecl.y"
#ifndef YYSTYPE
typedef union {
    lx_info info;
    int number;
    sm_ref reference;
    sm_list list;
    char *string;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		163
#define	YYFLAG		-32768
#define	YYNTBASE	54

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 307 ? yytranslate[x] : 94)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     4,     9,    10,    13,    14,    20,    23,
      24,    26,    28,    32,    34,    39,    43,    45,    49,    51,
      55,    58,    60,    62,    65,    67,    69,    71,    73,    75,
      77,    79,    81,    83,    85,    87,    88,    91,    93,    95,
      97,    99,   101,   104,   108,   111,   117,   125,   135,   136,
     138,   140,   142,   144,   146,   148,   152,   154,   159,   163,
     168,   172,   174,   178,   180,   183,   186,   189,   192,   194,
     199,   201,   205,   209,   213,   215,   219,   223,   225,   229,
     233,   235,   239,   243,   247,   251,   253,   257,   261,   263,
     265,   269,   271,   273,   277,   279,   283,   285,   289,   291,
     295,   297
};
static const short yyrhs[] =
{
      56,     0,    55,     0,     5,    56,    68,     6,     0,     0,
      56,    57,     0,     0,    59,    66,    58,    60,    30,     0,
       1,    30,     0,     0,    44,     0,    61,     0,    61,    23,
      65,     0,    52,     0,    52,     3,    62,     4,     0,    52,
       3,     4,     0,    63,     0,    63,    47,    48,     0,    64,
       0,    63,    47,    64,     0,    66,    61,     0,    87,     0,
      67,     0,    66,    67,     0,    34,     0,    35,     0,    36,
       0,    37,     0,    40,     0,    41,     0,    42,     0,    39,
       0,    38,     0,    43,     0,    53,     0,     0,    68,    69,
       0,    55,     0,    71,     0,    72,     0,    73,     0,    70,
       0,     1,    30,     0,    45,    74,    30,     0,    86,    30,
       0,    31,     3,    86,     4,    69,     0,    31,     3,    86,
       4,    69,    32,    69,     0,    33,     3,    74,    30,    74,
      30,    74,     4,    69,     0,     0,    86,     0,    49,     0,
      51,     0,    50,     0,    52,     0,    75,     0,     3,    86,
       4,     0,    76,     0,    77,     7,    86,     8,     0,    77,
       9,    52,     0,    77,     3,    78,     4,     0,    77,     3,
       4,     0,    87,     0,    78,    47,    87,     0,    77,     0,
      10,    80,     0,    29,    80,     0,    13,    80,     0,    14,
      80,     0,    79,     0,     3,    66,     4,    80,     0,    80,
       0,    81,    10,    80,     0,    81,    11,    80,     0,    81,
      12,    80,     0,    81,     0,    82,    13,    81,     0,    82,
      14,    81,     0,    82,     0,    83,    21,    82,     0,    83,
      22,    82,     0,    83,     0,    84,    16,    83,     0,    84,
      18,    83,     0,    84,    15,    83,     0,    84,    17,    83,
       0,    84,     0,    85,    19,    84,     0,    85,    20,    84,
       0,    87,     0,    88,     0,    79,    23,    87,     0,    89,
       0,    90,     0,    89,    24,    90,     0,    91,     0,    90,
      25,    91,     0,    92,     0,    91,    26,    92,     0,    93,
       0,    92,    28,    93,     0,    85,     0,    93,    27,    85,
       0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   180,   184,   190,   197,   199,   221,   221,   235,   240,
     242,   245,   247,   255,   265,   274,   285,   286,   301,   307,
     319,   326,   330,   336,   347,   353,   358,   363,   368,   373,
     378,   383,   388,   393,   398,   405,   407,   429,   431,   432,
     433,   434,   435,   441,   449,   457,   466,   478,   490,   493,
     495,   502,   509,   518,   524,   526,   532,   534,   541,   548,
     555,   564,   570,   584,   586,   593,   600,   607,   616,   618,
     626,   628,   637,   646,   657,   659,   668,   679,   681,   690,
     701,   703,   712,   721,   730,   741,   743,   752,   764,   770,
     773,   784,   788,   790,   801,   803,   814,   816,   827,   829,
     840,   842
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "LPAREN", "RPAREN", "LCURLY", "RCURLY", 
  "LBRACKET", "RBRACKET", "DOT", "STAR", "SLASH", "MODULUS", "PLUS", 
  "MINUS", "LEQ", "LT", "GEQ", "GT", "EQ", "NEQ", "LEFT_SHIFT", 
  "RIGHT_SHIFT", "ASSIGN", "LOG_OR", "LOG_AND", "ARITH_OR", "ARITH_AND", 
  "ARITH_XOR", "BANG", "SEMI", "IF", "ELSE", "FOR", "CHAR", "SHORT", 
  "INT", "LONG", "UNSIGNED", "SIGNED", "FLOAT", "DOUBLE", "VOID", 
  "STRING", "STATIC", "RETURN_TOKEN", "PRINT", "COMMA", "DOTDOTDOT", 
  "integer_constant", "string_constant", "floating_constant", 
  "identifier_ref", "type_id", "start", "compound_statement", 
  "declaration_list", "declaration", "@1", "static_opt", 
  "init_declarator", "declarator", "parameter_type_list", 
  "parameter_list", "parameter_declaration", "initializer", 
  "type_specifier_list", "type_specifier", "statement_list", "statement", 
  "jump_statement", "expression_statement", "selection_statement", 
  "iteration_statement", "expression_opt", "constant", 
  "primary_expression", "postfix_expression", "argument_expression_list", 
  "unary_expression", "cast_expression", "multiplicative_expression", 
  "additive_expression", "shift_expression", "relational_expression", 
  "equality_expression", "expression", "assignment_expression", 
  "conditional_expression", "logical_or_expression", 
  "logical_and_expression", "inclusive_or_expression", 
  "exclusive_or_expression", "and_expression", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    54,    54,    55,    56,    56,    58,    57,    57,    59,
      59,    60,    60,    61,    61,    61,    62,    62,    63,    63,
      64,    65,    66,    66,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    68,    68,    69,    69,    69,
      69,    69,    69,    70,    71,    72,    72,    73,    74,    74,
      75,    75,    75,    76,    76,    76,    77,    77,    77,    77,
      77,    78,    78,    79,    79,    79,    79,    79,    80,    80,
      81,    81,    81,    81,    82,    82,    82,    83,    83,    83,
      84,    84,    84,    84,    84,    85,    85,    85,    86,    87,
      87,    88,    89,    89,    90,    90,    91,    91,    92,    92,
      93,    93
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     1,     4,     0,     2,     0,     5,     2,     0,
       1,     1,     3,     1,     4,     3,     1,     3,     1,     3,
       2,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     1,     1,     1,
       1,     1,     2,     3,     2,     5,     7,     9,     0,     1,
       1,     1,     1,     1,     1,     3,     1,     4,     3,     4,
       3,     1,     3,     1,     2,     2,     2,     2,     1,     4,
       1,     3,     3,     3,     1,     3,     3,     1,     3,     3,
       1,     3,     3,     3,     3,     1,     3,     3,     1,     1,
       3,     1,     1,     3,     1,     3,     1,     3,     1,     3,
       1,     3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       4,     4,     2,     0,     0,     0,    10,     5,     0,     0,
       8,    24,    25,    26,    27,    32,    31,    28,    29,    30,
      33,    34,     6,    22,     0,     0,     3,     0,     0,     0,
       0,     0,     0,    48,    50,    52,    51,    53,    37,    36,
      41,    38,    39,    40,    54,    56,    63,    68,    70,    74,
      77,    80,    85,   100,     0,    88,    89,    91,    92,    94,
      96,    98,     0,    23,    42,     0,     0,    68,    64,    66,
      67,    65,     0,    48,     0,    49,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    44,     0,     0,     0,     0,     0,    13,
       0,    11,     0,    55,     0,     0,    43,    60,     0,    61,
       0,    58,    90,    71,    72,    73,    75,    76,    78,    79,
      83,    81,    84,    82,    86,    87,    93,    95,    97,    99,
     101,     0,     7,     0,    69,     0,    48,    59,     0,    57,
      15,     0,    16,    18,     0,    12,    21,    45,     0,    62,
      14,     0,    20,     0,    48,    17,    19,    46,     0,     0,
      47,     0,     0,     0
};

static const short yydefgoto[] =
{
     161,    38,     3,     7,    62,     8,   100,   101,   141,   142,
     143,   145,   144,    23,     9,    39,    40,    41,    42,    43,
      74,    44,    45,    46,   108,    67,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61
};

static const short yypact[] =
{
       9,-32768,-32768,    50,   133,   -12,-32768,-32768,   293,   104,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,   293,-32768,    -5,   210,-32768,   291,   291,   291,
     291,    25,    28,   291,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,    10,    22,-32768,    23,
      24,    39,     5,    52,    17,-32768,-32768,    32,    27,    36,
      38,    46,    30,-32768,-32768,   230,    91,-32768,-32768,-32768,
  -32768,-32768,   291,   291,    68,-32768,    26,   291,    49,   291,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   291,   291,-32768,   291,   291,   291,   291,   291,    99,
      74,    83,   291,-32768,   107,    78,-32768,-32768,     7,-32768,
     105,-32768,-32768,-32768,-32768,-32768,    23,    23,    24,    24,
      39,    39,    39,    39,     5,     5,    27,    36,    38,    46,
      52,   250,-32768,   291,-32768,   186,   291,-32768,   291,-32768,
  -32768,   111,    69,-32768,   169,-32768,-32768,    87,    90,-32768,
  -32768,   273,-32768,   186,   291,-32768,-32768,-32768,   117,   186,
  -32768,   122,   123,-32768
};

static const short yypgoto[] =
{
  -32768,   128,   130,-32768,-32768,-32768,-32768,    -4,-32768,-32768,
     -10,-32768,     2,   -19,-32768,  -127,-32768,-32768,-32768,-32768,
     -71,-32768,-32768,-32768,-32768,    -9,   -23,    -3,    11,   -46,
       8,    34,   -24,   -64,-32768,-32768,    48,    53,    55,    60
};


#define	YYLAST		346


static const short yytable[] =
{
      47,    66,   105,    63,    68,    69,    70,    71,   147,    75,
      22,   137,   109,    76,     1,   112,    47,    77,    10,    78,
      87,    88,    89,    90,    47,    64,   157,    65,    72,    25,
     107,    73,   160,    80,    81,    82,    27,    83,    84,    28,
      29,   120,   121,   122,   123,    79,    63,    93,   104,    75,
      -1,     5,    95,   110,   138,    30,    94,   113,   114,   115,
      85,    86,    96,    47,    47,   148,    97,    47,    47,   146,
      47,    91,    92,    98,   149,    34,    35,    36,    37,   134,
     116,   117,    99,   158,    -9,    -9,    -9,    -9,    -9,    -9,
      -9,    -9,    -9,    -9,     6,   103,   118,   119,   106,   124,
     125,   111,   131,    -9,   132,    24,   133,    25,   136,     1,
      26,   135,    75,   139,    27,   150,   151,    28,    29,   153,
     154,   159,   162,   163,    47,    63,    47,    47,     2,    47,
      75,     4,   130,    30,     5,    31,   -35,    32,   -35,   -35,
     152,   156,   126,   -35,    47,    47,   -35,   -35,   127,    33,
      47,   128,     0,    34,    35,    36,    37,   129,     0,     0,
       0,     0,   -35,     0,   -35,     0,   -35,    -9,    -9,    -9,
      -9,    -9,    -9,    -9,    -9,    -9,    -9,     6,   -35,     0,
       0,     0,   -35,   -35,   -35,   -35,    -9,    24,     0,    25,
       0,     1,     0,     0,     0,     0,    27,     0,     0,    28,
      29,     0,     0,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    25,     0,    30,     0,    31,     0,    32,
      27,    99,    21,    28,    29,     0,     0,     0,     0,     0,
       0,    33,     0,     0,   102,    34,    35,    36,    37,    30,
       0,     0,     0,     0,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,   140,     0,     0,     0,     0,    34,
      35,    36,    37,    21,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    21,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    25,     0,     0,     0,     0,     0,
       0,    27,     0,    21,    28,    29,     0,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,     0,     0,     0,
      30,   155,     0,     0,     0,     0,    21,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,     0,     0,     0,
      34,    35,    36,    37,     0,     0,    21
};

static const short yycheck[] =
{
       9,    25,    73,    22,    27,    28,    29,    30,   135,    33,
       8,     4,    76,     3,     5,    79,    25,     7,    30,     9,
      15,    16,    17,    18,    33,    30,   153,    25,     3,     3,
       4,     3,   159,    10,    11,    12,    10,    13,    14,    13,
      14,    87,    88,    89,    90,    23,    65,    30,    72,    73,
       0,     1,    25,    77,    47,    29,    24,    80,    81,    82,
      21,    22,    26,    72,    73,   136,    28,    76,    77,   133,
      79,    19,    20,    27,   138,    49,    50,    51,    52,   102,
      83,    84,    52,   154,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,     4,    85,    86,    30,    91,
      92,    52,     3,    53,    30,     1,    23,     3,    30,     5,
       6,     4,   136,     8,    10,     4,    47,    13,    14,    32,
      30,     4,     0,     0,   133,   144,   135,   136,     0,   138,
     154,     1,    98,    29,     1,    31,     3,    33,     5,     6,
     144,   151,    94,    10,   153,   154,    13,    14,    95,    45,
     159,    96,    -1,    49,    50,    51,    52,    97,    -1,    -1,
      -1,    -1,    29,    -1,    31,    -1,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    49,    50,    51,    52,    53,     1,    -1,     3,
      -1,     5,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      14,    -1,    -1,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,     3,    -1,    29,    -1,    31,    -1,    33,
      10,    52,    53,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,     4,    49,    50,    51,    52,    29,
      -1,    -1,    -1,    -1,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,     4,    -1,    -1,    -1,    -1,    49,
      50,    51,    52,    53,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    53,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    53,    13,    14,    -1,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    -1,    -1,    -1,
      29,    48,    -1,    -1,    -1,    -1,    53,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    -1,    -1,    -1,
      49,    50,    51,    52,    -1,    -1,    53
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 181 "ecl.y"
{
	    yyparse_value = (sm_ref)yyvsp[0].list;
	}
    break;
case 2:
#line 185 "ecl.y"
{
	    yyparse_value = yyvsp[0].reference;
	}
    break;
case 3:
#line 191 "ecl.y"
{
	    yyval.reference = ecl_new_compound_statement();
	    yyval.reference->node.compound_statement.decls = yyvsp[-2].list;
	    yyval.reference->node.compound_statement.statements = yyvsp[-1].list;
	}
    break;
case 4:
#line 198 "ecl.y"
{ yyval.list = NULL; }
    break;
case 5:
#line 200 "ecl.y"
{
	    if (yyvsp[0].reference == NULL) {
		yyval.list = yyvsp[-1].list;
	    } else {
		if (yyvsp[-1].list == NULL) {
		    yyval.list = malloc(sizeof(struct list_struct));
		    yyval.list->node = yyvsp[0].reference;
		    yyval.list->next = NULL;
		} else {
		    sm_list tmp = yyvsp[-1].list;
		    while (tmp->next != NULL) {
			tmp = tmp->next;
		    }
		    tmp->next = malloc(sizeof(struct list_struct));
		    tmp->next->node = yyvsp[0].reference;
		    tmp->next->next = NULL;
		    yyval.list = yyvsp[-1].list;
		}
	    }
	}
    break;
case 6:
#line 223 "ecl.y"
{ 
		 if (parsing_type) {
		     yyparse_value = (sm_ref) yyvsp[0].list;
		     YYACCEPT;
		 }
	     }
    break;
case 7:
#line 230 "ecl.y"
{
		yyval.reference = yyvsp[-1].reference;
		yyval.reference->node.declaration.static_var = yyvsp[-4].number;
		yyval.reference->node.declaration.type_spec = yyvsp[-3].list;
	    }
    break;
case 8:
#line 235 "ecl.y"
{
	    yyval.reference = NULL;
	}
    break;
case 9:
#line 241 "ecl.y"
{yyval.number = 0;}
    break;
case 10:
#line 242 "ecl.y"
{ yyval.number = 1;}
    break;
case 12:
#line 249 "ecl.y"
{
		assert(yyvsp[-2].reference->node_type == ecl_declaration);
		yyvsp[-2].reference->node.declaration.init_value = yyvsp[0].reference;
	    }
    break;
case 13:
#line 256 "ecl.y"
{
		yyval.reference = ecl_new_declaration();
		yyval.reference->node.declaration.param_num = -1;
		yyval.reference->node.declaration.id = yyvsp[0].info.string;
		yyval.reference->node.declaration.init_value = NULL;
		yyval.reference->node.declaration.lx_srcpos = yyvsp[0].info.lx_srcpos;
		yyval.reference->node.declaration.is_subroutine = 0;
		yyval.reference->node.declaration.params = NULL;
	    }
    break;
case 14:
#line 265 "ecl.y"
{
		yyval.reference = ecl_new_declaration();
		yyval.reference->node.declaration.param_num = -1;
		yyval.reference->node.declaration.id = yyvsp[-3].info.string;
		yyval.reference->node.declaration.init_value = NULL;
		yyval.reference->node.declaration.lx_srcpos = yyvsp[-3].info.lx_srcpos;
		yyval.reference->node.declaration.is_subroutine = 1;
		yyval.reference->node.declaration.params = yyvsp[-1].list;
	}
    break;
case 15:
#line 274 "ecl.y"
{
		yyval.reference = ecl_new_declaration();
		yyval.reference->node.declaration.param_num = -1;
		yyval.reference->node.declaration.id = yyvsp[-2].info.string;
		yyval.reference->node.declaration.init_value = NULL;
		yyval.reference->node.declaration.lx_srcpos = yyvsp[-2].info.lx_srcpos;
		yyval.reference->node.declaration.is_subroutine = 1;
		yyval.reference->node.declaration.params = NULL;
	}
    break;
case 17:
#line 287 "ecl.y"
{
	    sm_list tmp = yyvsp[-2].list;
	    sm_ref id = ecl_new_declaration();
	    while (tmp->next != NULL) {
		tmp = tmp->next;
	    }
	    tmp->next = malloc(sizeof(struct list_struct));
	    tmp->next->node = id;
	    tmp->next->next = NULL;
	    id->node.declaration.id = strdup("...");
	    yyval.list = yyvsp[-2].list;
	}
    break;
case 18:
#line 302 "ecl.y"
{
		yyval.list = malloc(sizeof(struct list_struct));
		yyval.list->node = yyvsp[0].reference;
		yyval.list->next = NULL;
	}
    break;
case 19:
#line 308 "ecl.y"
{
	    sm_list tmp = yyvsp[-2].list;
	    while (tmp->next != NULL) {
		tmp = tmp->next;
	    }
	    tmp->next = malloc(sizeof(struct list_struct));
	    tmp->next->node = yyvsp[0].reference;
	    tmp->next->next = NULL;
	    yyval.list = yyvsp[-2].list;
	}
    break;
case 20:
#line 320 "ecl.y"
{
		yyval.reference = yyvsp[0].reference;
		yyval.reference->node.declaration.static_var = 0;
		yyval.reference->node.declaration.type_spec = yyvsp[-1].list;
	}
    break;
case 21:
#line 327 "ecl.y"
{ yyval.reference = yyvsp[0].reference;}
    break;
case 22:
#line 331 "ecl.y"
{
	    yyval.list = malloc(sizeof(struct list_struct));
	    yyval.list->node = yyvsp[0].reference;
	    yyval.list->next = NULL;
	}
    break;
case 23:
#line 336 "ecl.y"
{
	    sm_list tmp = yyvsp[-1].list;
	    while (tmp->next != NULL) {
		tmp = tmp->next;
	    }
	    tmp->next = malloc(sizeof(struct list_struct));
	    tmp->next->node = yyvsp[0].reference;
	    tmp->next->next = NULL;
	    yyval.list = yyvsp[-1].list;
	}
    break;
case 24:
#line 348 "ecl.y"
{
	    yyval.reference = ecl_new_type_specifier();
	    yyval.reference->node.type_specifier.lx_srcpos = yyvsp[0].info.lx_srcpos;
	    yyval.reference->node.type_specifier.token = CHAR;
	}
    break;
case 25:
#line 353 "ecl.y"
{
	    yyval.reference = ecl_new_type_specifier();
	    yyval.reference->node.type_specifier.lx_srcpos = yyvsp[0].info.lx_srcpos;
	    yyval.reference->node.type_specifier.token = SHORT;
	}
    break;
case 26:
#line 358 "ecl.y"
{
	    yyval.reference = ecl_new_type_specifier();
	    yyval.reference->node.type_specifier.lx_srcpos = yyvsp[0].info.lx_srcpos;
	    yyval.reference->node.type_specifier.token = INT;
	}
    break;
case 27:
#line 363 "ecl.y"
{
	    yyval.reference = ecl_new_type_specifier();
	    yyval.reference->node.type_specifier.lx_srcpos = yyvsp[0].info.lx_srcpos;
	    yyval.reference->node.type_specifier.token = LONG;
	}
    break;
case 28:
#line 368 "ecl.y"
{
	    yyval.reference = ecl_new_type_specifier();
	    yyval.reference->node.type_specifier.lx_srcpos = yyvsp[0].info.lx_srcpos;
	    yyval.reference->node.type_specifier.token = FLOAT;
	}
    break;
case 29:
#line 373 "ecl.y"
{
	    yyval.reference = ecl_new_type_specifier();
	    yyval.reference->node.type_specifier.lx_srcpos = yyvsp[0].info.lx_srcpos;
	    yyval.reference->node.type_specifier.token = DOUBLE;
	}
    break;
case 30:
#line 378 "ecl.y"
{
	    yyval.reference = ecl_new_type_specifier();
	    yyval.reference->node.type_specifier.lx_srcpos = yyvsp[0].info.lx_srcpos;
	    yyval.reference->node.type_specifier.token = VOID;
	}
    break;
case 31:
#line 383 "ecl.y"
{
	    yyval.reference = ecl_new_type_specifier();
	    yyval.reference->node.type_specifier.lx_srcpos = yyvsp[0].info.lx_srcpos;
	    yyval.reference->node.type_specifier.token = SIGNED;
	}
    break;
case 32:
#line 388 "ecl.y"
{
	    yyval.reference = ecl_new_type_specifier();
	    yyval.reference->node.type_specifier.lx_srcpos = yyvsp[0].info.lx_srcpos;
	    yyval.reference->node.type_specifier.token = UNSIGNED;
	}
    break;
case 33:
#line 393 "ecl.y"
{
	    yyval.reference = ecl_new_type_specifier();
	    yyval.reference->node.type_specifier.lx_srcpos = yyvsp[0].info.lx_srcpos;
	    yyval.reference->node.type_specifier.token = STRING;
	}
    break;
case 34:
#line 398 "ecl.y"
{
	    yyval.reference = ecl_new_identifier();
	    yyval.reference->node.identifier.lx_srcpos = yyvsp[0].info.lx_srcpos;
	    yyval.reference->node.identifier.id = yyvsp[0].info.string;
	}
    break;
case 35:
#line 406 "ecl.y"
{yyval.list = NULL;}
    break;
case 36:
#line 407 "ecl.y"
{
	    if (yyvsp[0].reference == NULL) {
		yyval.list = yyvsp[-1].list;
	    } else {
		if (yyvsp[-1].list == NULL) {
		    yyval.list = malloc(sizeof(struct list_struct));
		    yyval.list->node = yyvsp[0].reference;
		    yyval.list->next = NULL;
		} else {
		    sm_list tmp = yyvsp[-1].list;
		    while (tmp->next != NULL) {
			tmp = tmp->next;
		    }
		    tmp->next = malloc(sizeof(struct list_struct));
		    tmp->next->node = yyvsp[0].reference;
		    tmp->next->next = NULL;
		    yyval.list = yyvsp[-1].list;
		}
	    }
	}
    break;
case 42:
#line 435 "ecl.y"
{
	      yyval.reference = NULL;
	  }
    break;
case 43:
#line 442 "ecl.y"
{
	    yyval.reference = ecl_new_return_statement();
	    yyval.reference->node.return_statement.expression = yyvsp[-1].reference;
	    yyval.reference->node.return_statement.lx_srcpos = yyvsp[-2].info.lx_srcpos;
	}
    break;
case 44:
#line 450 "ecl.y"
{ 
	    yyval.reference = ecl_new_expression_statement();
	    yyval.reference->node.expression_statement.expression = yyvsp[-1].reference;
	}
    break;
case 45:
#line 459 "ecl.y"
{ 
	    yyval.reference = ecl_new_selection_statement();
	    yyval.reference->node.selection_statement.lx_srcpos = yyvsp[-4].info.lx_srcpos;
	    yyval.reference->node.selection_statement.conditional = yyvsp[-2].reference;
	    yyval.reference->node.selection_statement.then_part = yyvsp[0].reference;
	    yyval.reference->node.selection_statement.else_part = NULL;
	}
    break;
case 46:
#line 468 "ecl.y"
{ 
	    yyval.reference = ecl_new_selection_statement();
	    yyval.reference->node.selection_statement.lx_srcpos = yyvsp[-6].info.lx_srcpos;
	    yyval.reference->node.selection_statement.conditional = yyvsp[-4].reference;
	    yyval.reference->node.selection_statement.then_part = yyvsp[-2].reference;
	    yyval.reference->node.selection_statement.else_part = yyvsp[0].reference;
	}
    break;
case 47:
#line 480 "ecl.y"
{ 
	    yyval.reference = ecl_new_iteration_statement();
	    yyval.reference->node.selection_statement.lx_srcpos = yyvsp[-8].info.lx_srcpos;
	    yyval.reference->node.iteration_statement.init_expr = yyvsp[-6].reference;
	    yyval.reference->node.iteration_statement.test_expr = yyvsp[-4].reference;
	    yyval.reference->node.iteration_statement.iter_expr = yyvsp[-2].reference;
	    yyval.reference->node.iteration_statement.statement = yyvsp[0].reference;
	}
    break;
case 48:
#line 491 "ecl.y"
{ yyval.reference = NULL; }
    break;
case 50:
#line 496 "ecl.y"
{
	    yyval.reference = ecl_new_constant();
	    yyval.reference->node.constant.token = integer_constant;
	    yyval.reference->node.constant.const_val = yyvsp[0].info.string;
	    yyval.reference->node.constant.lx_srcpos = yyvsp[0].info.lx_srcpos;
	}
    break;
case 51:
#line 503 "ecl.y"
{
	    yyval.reference = ecl_new_constant();
	    yyval.reference->node.constant.token = floating_constant;
	    yyval.reference->node.constant.const_val = yyvsp[0].info.string;
	    yyval.reference->node.constant.lx_srcpos = yyvsp[0].info.lx_srcpos;
	}
    break;
case 52:
#line 510 "ecl.y"
{
	    yyval.reference = ecl_new_constant();
	    yyval.reference->node.constant.token = string_constant;
	    yyval.reference->node.constant.const_val = yyvsp[0].info.string;
	    yyval.reference->node.constant.lx_srcpos = yyvsp[0].info.lx_srcpos;
	}
    break;
case 53:
#line 519 "ecl.y"
{
	    yyval.reference = ecl_new_identifier();
	    yyval.reference->node.identifier.id = yyvsp[0].info.string;
	    yyval.reference->node.identifier.lx_srcpos = yyvsp[0].info.lx_srcpos;
	}
    break;
case 55:
#line 528 "ecl.y"
{ yyval.reference = yyvsp[-1].reference; }
    break;
case 57:
#line 535 "ecl.y"
{
	    yyval.reference = ecl_new_element_ref();
	    yyval.reference->node.element_ref.lx_srcpos = yyvsp[-2].info.lx_srcpos;
	    yyval.reference->node.element_ref.expression = yyvsp[-1].reference;
	    yyval.reference->node.element_ref.array_ref = yyvsp[-3].reference;
	}
    break;
case 58:
#line 542 "ecl.y"
{
	    yyval.reference = ecl_new_field_ref();
	    yyval.reference->node.field_ref.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.field_ref.lx_field = yyvsp[0].info.string;
	    yyval.reference->node.field_ref.struct_ref = yyvsp[-2].reference;
	}
    break;
case 59:
#line 549 "ecl.y"
{
	    yyval.reference = ecl_new_subroutine_call();
	    yyval.reference->node.subroutine_call.lx_srcpos = yyvsp[-2].info.lx_srcpos;
	    yyval.reference->node.subroutine_call.arguments = yyvsp[-1].list;
	    yyval.reference->node.subroutine_call.sm_func_ref = yyvsp[-3].reference;
	}
    break;
case 60:
#line 556 "ecl.y"
{
	    yyval.reference = ecl_new_subroutine_call();
	    yyval.reference->node.subroutine_call.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.subroutine_call.arguments = NULL;
	    yyval.reference->node.subroutine_call.sm_func_ref = yyvsp[-2].reference;
	}
    break;
case 61:
#line 565 "ecl.y"
{
		yyval.list = malloc(sizeof(struct list_struct));
		yyval.list->node = yyvsp[0].reference;
		yyval.list->next = NULL;
	}
    break;
case 62:
#line 571 "ecl.y"
{
	    sm_list tmp = yyvsp[-2].list;
	    while (tmp->next != NULL) {
		tmp = tmp->next;
	    }
	    tmp->next = malloc(sizeof(struct list_struct));
	    tmp->next->node = yyvsp[0].reference;
	    tmp->next->next = NULL;
	    yyval.list = yyvsp[-2].list;
	}
    break;
case 64:
#line 586 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_deref;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = NULL;
	}
    break;
case 65:
#line 593 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_log_neg;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = NULL;
	}
    break;
case 66:
#line 600 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_plus;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = NULL;
	}
    break;
case 67:
#line 607 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_minus;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = NULL;
	}
    break;
case 69:
#line 618 "ecl.y"
{
	    yyval.reference = ecl_new_cast();
	    yyval.reference->node.cast.lx_srcpos = yyvsp[-3].info.lx_srcpos;
	    yyval.reference->node.cast.type_spec = yyvsp[-2].list;
	    yyval.reference->node.cast.expression = yyvsp[0].reference;
	}
    break;
case 71:
#line 630 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_mult;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 72:
#line 639 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_div;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 73:
#line 648 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_modulus;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 75:
#line 661 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.op = op_plus;
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 76:
#line 670 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_minus;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 78:
#line 683 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_left_shift;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 79:
#line 692 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_right_shift;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 81:
#line 705 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_lt;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 82:
#line 714 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_gt;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 83:
#line 723 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_leq;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 84:
#line 732 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_geq;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 86:
#line 745 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_eq;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 87:
#line 754 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_neq;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 88:
#line 766 "ecl.y"
{yyval.reference = yyvsp[0].reference;}
    break;
case 89:
#line 772 "ecl.y"
{ yyval.reference = yyvsp[0].reference;}
    break;
case 90:
#line 775 "ecl.y"
{
	    yyval.reference = ecl_new_assignment_expression();
	    yyval.reference->node.assignment_expression.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.assignment_expression.left = yyvsp[-2].reference;
	    yyval.reference->node.assignment_expression.right = yyvsp[0].reference;
	}
    break;
case 93:
#line 792 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_log_or;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 95:
#line 805 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_log_and;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 97:
#line 818 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_arith_or;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 99:
#line 831 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_arith_xor;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
case 101:
#line 844 "ecl.y"
{
	    yyval.reference = ecl_new_operator();
	    yyval.reference->node.operator.lx_srcpos = yyvsp[-1].info.lx_srcpos;
	    yyval.reference->node.operator.op = op_arith_and;
	    yyval.reference->node.operator.right = yyvsp[0].reference;
	    yyval.reference->node.operator.left = yyvsp[-2].reference;
	}
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 853 "ecl.y"

#include "lex.yy.c"

typedef struct scope *scope_ptr;

struct parse_struct {
    sm_list decls;
    scope_ptr scope;
    int defined_type_count;
    char **defined_types;
    err_out_func_t error_func;
    void *client_data;
    sm_list return_type_list;
    int return_cg_type;
};


static int
semanticize_compound_statement(ecl_parse_context context, sm_ref compound, 
			       scope_ptr containing_scope);
static int semanticize_decls_list(ecl_parse_context context, sm_list decls, 
				  scope_ptr scope);
static void add_decl(char *id, sm_ref node, scope_ptr scope);
static sm_ref get_complex_type(ecl_parse_context context, sm_ref node);
static sm_ref find_complex_type(sm_ref node, scope_ptr scope);
static char *ecl_code_string;
static int is_string(sm_ref expr);


int
ecl_parse_for_context(code, context)
char *code;
ecl_parse_context context;
{
    sm_list decls;
    int ret;
#ifndef MODULE
#ifdef YYDEBUG
    extern int yydebug;
    yydebug = 1;
#endif
#endif
    if (code != NULL) {
	setup_for_string_parse(code, context->defined_type_count, context->defined_types);
	ecl_code_string = code;
    }
    yyerror_count = 0;
    yycontext = context;
    yyparse();
    terminate_string_parse();

    if ((yyparse_value == NULL) || (yyerror_count != 0)) {
	return 0;
    }

    decls = (sm_list) yyparse_value;
    context->decls = decls;
    ret = semanticize_decls_list(context, decls, context->scope);
    if (ret == 0) {
	ecl_rfree_list(decls, NULL);
	context->decls = NULL;
    }
    return ret;
}

ecl_code
ecl_code_gen(code, context)
char *code;
ecl_parse_context context;
{
    sm_ref tmp;
    ecl_code ret_code;
    unsigned int offset;
    void *func;

    if (code != NULL) {
	setup_for_string_parse(code, context->defined_type_count, context->defined_types);
	ecl_code_string = code;
    }

    yyerror_count = 0;
    yycontext = context;
    yyparse();
    terminate_string_parse();

    if ((yyparse_value == NULL) || (yyerror_count != 0)) {
	return 0;
    }
    tmp = ecl_new_compound_statement();
    tmp->node.compound_statement.decls = context->decls;
    tmp->node.compound_statement.statements =
	malloc(sizeof(struct list_struct));
    tmp->node.compound_statement.statements->next = NULL;
    tmp->node.compound_statement.statements->node = yyparse_value;
    if (!semanticize_compound_statement(context, tmp, context->scope)) {
	tmp->node.compound_statement.decls = NULL;
	ecl_rfree(tmp);
	return NULL;
    }
    ret_code = malloc(sizeof(struct _ecl_code_struct));
    ret_code->code_memory_block = NULL;
    func = ecl_cg_net(tmp, &offset, ret_code);
    tmp->node.compound_statement.decls = NULL;
    ecl_rfree(tmp);
    ret_code->func = (void(*)())(long)func;
    ret_code->data = NULL;
    return ret_code;
}

void 
ecl_dump(ecl_code code)
{
    printf("ECL CODE structure %lx - \n", (long) code);
    printf("  function pointer %lx, code memory block %lx, data %lx, static size %d\n",
	   (long) code->func, (long) code->code_memory_block,
	   (long) code->data, code->static_size_required);
#ifndef HAVE_ICODE_H
#ifdef HAVE_DRISC_H
    dr_dump((drisc_ctx) code->drisc_context);
#endif
#else
    v_dump((void*)(long)code->func);
#endif
}
    

int
ecl_code_verify(code, context)
char *code;
ecl_parse_context context;
{
    sm_ref tmp;

    if (code != NULL) {
	setup_for_string_parse(code, context->defined_type_count, context->defined_types);
	ecl_code_string = code;
    }

    yyerror_count = 0;
    yycontext = context;
    yyparse();
    terminate_string_parse();

    if ((yyparse_value == NULL) || (yyerror_count != 0)) {
	return 0;
    }

    tmp = ecl_new_compound_statement();
    tmp->node.compound_statement.decls = context->decls;
    tmp->node.compound_statement.statements =
	malloc(sizeof(struct list_struct));
    tmp->node.compound_statement.statements->next = NULL;
    tmp->node.compound_statement.statements->node = yyparse_value;
    if (semanticize_compound_statement(context, tmp, context->scope) == 0) {
	tmp->node.compound_statement.decls = NULL;
	ecl_rfree(tmp);
	return 0;
    }
    tmp->node.compound_statement.decls = NULL;
    ecl_rfree(tmp);
    return 1;
}

extern void 
ecl_code_free(code)
ecl_code code;
{
    if (code->code_memory_block) free(code->code_memory_block);
    if (code->data) free(code->data);
    free(code);
}

static char *
copy_line(char *line_begin)
{
    char *line_end;
    if ((line_end = strchr(line_begin, 10)) == NULL) {
	/* no CR */
	return strdup(line_begin);
    } else {
	char *tmp = malloc(line_end - line_begin + 1);
	strncpy(tmp, line_begin, line_end - line_begin);
	tmp[line_end - line_begin] = 0;
	return tmp;
    }
}

static void
default_error_out(void *client_data, char *string)
{
    fprintf(stderr, "%s", string);
}

static void
print_context(ecl_parse_context context, int line, int character)
{
    char *tmp = ecl_code_string;
    char *line_begin = ecl_code_string;
    char *line_copy = NULL;
    int i, line_len, offset = 0;

    while (line > 1) {
	switch(*tmp) {
	case 10:
	    line_begin = tmp + 1;
	    line--;
	    break;
	case 0:
	    line = 1;   /* end of src */
	    break;
	}
	tmp++;
    }
    if (character > 40) {
	offset = character - 40;
    }
    line_copy = copy_line(line_begin + offset);
    line_len = strlen(line_copy);
    if (line_len > 60) {
	line_copy[60] = NULL;
    }
    context->error_func(context->client_data, line_copy);
    context->error_func(context->client_data, "\n");
    free(line_copy);
    for(i=offset + 1; i< character; i++) {
	if (line_begin[i-1] == '\t') {
	    context->error_func(context->client_data, "\t");
	} else {
	    context->error_func(context->client_data, " ");
	}
    }
    context->error_func(context->client_data, "^\n");
}

void yyerror(str)
char *str;
{
    char tmp_str[100];
    yycontext->error_func(yycontext->client_data, "## Error ");
    yycontext->error_func(yycontext->client_data, str);
    yycontext->error_func(yycontext->client_data, "\n");
    yycontext->error_func(yycontext->client_data, "## While parsing near ");
    yycontext->error_func(yycontext->client_data, yytext);
    sprintf(tmp_str, ", offset = %d, line = %d ####\n",lex_offset,line_count);
    yycontext->error_func(yycontext->client_data, tmp_str);
    print_context(yycontext, line_count, lex_offset);
    yyerror_count++;
}

#ifdef STDC_HEADERS
static void
ecl_src_error(ecl_parse_context context, sm_ref expr, char *format, ...)
#else
static void
ecl_src_error(context, expr, format, va_alist)
ecl_parse_context context;
sm_ref expr;
char *format;
va_dcl
#endif
{

    va_list ap;
    char *tmp = malloc(10240); /* arbitrarily large */
    srcpos lx_srcpos = ecl_get_srcpos(expr);
#ifdef STDC_HEADERS
    va_start(ap, format);
#else
    va_start(ap);
#endif
    context->error_func(context->client_data, "## Ecode Error:  ");
    vsprintf(tmp, format, ap);
    context->error_func(context->client_data, tmp);
    sprintf(tmp, " at line %d, char %d\n", lx_srcpos.line, lx_srcpos.character);
    context->error_func(context->client_data, tmp);
    free(tmp);
    print_context(context, lx_srcpos.line, lx_srcpos.character);
}

extern void
ecl_print_operator_t(operator_t o)
{
    switch (o) {
    case  op_modulus:
	printf("MODULUS");
	break;
    case  op_plus:
	printf("PLUS");
	break;
    case  op_minus:
	printf("MINUS");
	break;
    case  op_leq:
	printf("LEQ");
	break;
    case  op_lt:
	printf("LESS THAN");
	break;
    case  op_geq:
	printf("GEQ");
	break;
    case  op_gt:
	printf("GREATER THAN");
	break;
    case  op_eq:
	printf("EQUAL");
	break;
    case  op_neq:
	printf("NOT EQUAL");
	break;
    case  op_log_or:
	printf("LOGICAL OR");
	break;
    case  op_log_and:
	printf("LOGICAL AND");
	break;
    case op_log_neg:
	printf("LOGICAL NEGATION");
	break;
    case op_arith_and:
	printf("ARITH AND");
	break;
    case op_arith_or:
	printf("ARITH OR");
	break;
    case op_arith_xor:
	printf("ARITH XOR");
	break;
    case op_left_shift:
	printf("LEFT SHIFT");
	break;
    case op_right_shift:
	printf("RIGHT SHIFT");
	break;
    case  op_mult:
	printf("MULTIPLY");
	break;
    case  op_div:
	printf("DIVISION");
	break;
    case  op_deref:
	printf("DEREFERENCE");
	break;
    }
}

extern void
ecl_print_srcpos(srcpos pos)
{
    printf("line %d, char %d", pos.line, pos.character);
}

typedef struct st_entry {
    char *id;
    sm_ref node;
    struct st_entry *next;
} *st_entry;

struct scope {
    ecl_extern_list externs;
    struct st_entry *entry_list;
    struct scope *containing_scope;
};


extern ecl_parse_context
ecl_copy_context(context)
ecl_parse_context context;
{
    int i;
    ecl_parse_context new_context = new_ecl_parse_context();
    new_context->decls = ecl_copy_list(context->decls);
    new_context->scope->externs = context->scope->externs;
    new_context->error_func = context->error_func;
    new_context->client_data = context->client_data;
    semanticize_decls_list(new_context, new_context->decls, 
			   new_context->scope);
    new_context->defined_types = malloc(sizeof(char*) *
					context->defined_type_count);
    for (i=0; i< context->defined_type_count; i++) {
	new_context->defined_types[i] = context->defined_types[i];
    }
    return new_context;
}

static void *
resolve_extern(char *id, scope_ptr scope)
{
    if (scope == NULL) return NULL;
    if (scope->externs != NULL) {
	ecl_extern_list externs = scope->externs;
	while(externs->extern_name != NULL) {
	    if (strcmp(id, externs->extern_name) == 0) {
		return externs->extern_value;
	    }
	    externs++;
	}
    }
    return resolve_extern(id, scope->containing_scope);
}

static scope_ptr
push_scope(scope_ptr containing_scope)
{
    scope_ptr new_scope = malloc(sizeof(*new_scope));
    new_scope->externs = NULL;
    new_scope->entry_list = NULL;
    new_scope->containing_scope = containing_scope;
    return new_scope;
}

static void
pop_scope(scope_ptr scope)
{
    st_entry list = scope->entry_list;
    while (list != NULL) {
	st_entry tmp = list->next;
	free(list);
	list = tmp;
    }
    free(scope);
}

static void
add_decl(char *id, sm_ref node, scope_ptr scope)
{
    st_entry entry = malloc(sizeof(*entry));
    entry->node = node;
    entry->id = id;
    entry->next = scope->entry_list;
    scope->entry_list = entry;
}

static sm_ref
resolve_local(char *id, scope_ptr scope)
{
    st_entry list = scope->entry_list;
    while(list != NULL) {
	if (strcmp(list->id, id) == 0) {
	    return list->node;
	}
	list = list->next;
    }
    return NULL;
}

static sm_ref
resolve(char *id, scope_ptr scope)
{
    sm_ref tmp;
    if (scope == NULL) return NULL;
    if ((tmp = resolve_local(id, scope)) != NULL) {
	return tmp;
    }
    return resolve(id, scope->containing_scope);
}

static int 
determine_op_type(ecl_parse_context context, sm_ref expr, 
		  int left_type, int right_type)
{
    int unsigned_used = 0;
    operator_t op = expr->node.operator.op;
    if (left_type == DR_P) {
	if (is_string(expr->node.operator.left) &&
	    is_string(expr->node.operator.right) &&
	    (op == op_eq)) {
	    return DR_I;
	} else {
	    ecl_src_error(context, expr, 
			  "Illegal arithmetic.  Left side is a pointer value");
	    return DR_ERR;
	}
    }
    if (right_type == DR_P) {
	ecl_src_error(context, expr, 
		      "Illegal arithmetic.  Right side is a pointer value");
	return DR_ERR;
    }
    if (left_type == DR_B) {
	ecl_src_error(context, expr, 
		      "Illegal arithmetic.  Left side is a structured type");
	return DR_ERR;
    }
    if (right_type == DR_B) {
	ecl_src_error(context, expr, 
		      "Illegal arithmetic.  Right side is a structured type");
	return DR_ERR;
    }
    if ((left_type == DR_D) || (right_type == DR_D)) {
	if ((op == op_modulus) || (op == op_log_or) || (op == op_log_and)) {
	    ecl_src_error(context, expr, "Operands must be integral.");
	    return DR_ERR;
	} else {
	    return DR_D;
	}
    }
    if ((left_type == DR_F) || (right_type == DR_F)) {
	if ((op == op_modulus) || (op == op_log_or) || (op == op_log_and)) {
	    ecl_src_error(context, expr, "Operands must be integral.");
	    return DR_ERR;

	} else {
	    return DR_F;
	}
    }
    switch(left_type) {
    case DR_C: case DR_UC: case DR_S: case DR_US:
	left_type = DR_I;   /* integer promotion */
    }
    switch(right_type) {
    case DR_C: case DR_UC: case DR_S: case DR_US:
	right_type = DR_I;   /* integer promotion */
    }
    switch(left_type) {
    case DR_UC: case DR_US: case DR_U: case DR_UL:
	unsigned_used++;
    }
    switch(right_type) {
    case DR_UC: case DR_US: case DR_U: case DR_UL:
	unsigned_used++;
    }
    if ((op == op_left_shift) || (op == op_right_shift)) return left_type;
    if ((left_type == DR_UL) || (right_type == DR_UL)) return DR_UL;
    if ((left_type == DR_L) || (right_type == DR_L)) return unsigned_used? DR_UL : DR_L;
    if ((left_type == DR_U) || (right_type == DR_U)) return DR_U;
    return unsigned_used? DR_U: DR_I;
}

static int reduce_type_list(ecl_parse_context context, sm_list type_list);

static int
is_n_dimen_array(int dimen, sm_ref expr)
{
    if (expr->node_type == ecl_field_ref) {
	return is_n_dimen_array(dimen, expr->node.field_ref.sm_field_ref);
    }
    if (expr->node_type == ecl_element_ref) {
	return is_n_dimen_array(dimen + 1, expr);
    }
    if (expr->node_type != ecl_field) return 0;
    if ((expr->node.field.sm_var_control_field != NULL) && (dimen != 1)) return 0;

    switch(dimen) {
    case 1:
	if ((expr->node.field.dimen1 != 1) && (expr->node.field.dimen2 == 1))
	    return 1;
	return 0;
    case 2:
	if ((expr->node.field.dimen1 != 1) && (expr->node.field.dimen2 != 1))
	    return 1;
	return 0;
    }
    return 0;
}

static int 
is_string(sm_ref expr)
{
    if (expr->node_type == ecl_field) {
	return (strcmp(expr->node.field.string_type, "string") == 0);
    } else if (expr->node_type == ecl_field_ref) {
	return is_string(expr->node.field_ref.sm_field_ref);
    } else if (expr->node_type == ecl_identifier) {
	return is_string(expr->node.identifier.sm_declaration);
    } else if (expr->node_type == ecl_declaration) {
	if (expr->node.declaration.cg_type != DR_P) return 0;
	if (expr->node.declaration.sm_complex_type != NULL) return 0;
	/* only strings have pointers without complex types */
	return 1;
    } else if (expr->node_type == ecl_constant) {
	return (expr->node.constant.token == string_constant);
    }
    return 0;
}

extern int 
ecl_expr_is_string(sm_ref expr)
{
    return is_string(expr);
}

extern int 
is_control_value(sm_ref expr, sm_ref strct)
{
    sm_list fields;
    if (expr->node_type == ecl_field_ref) {
	return is_control_value(expr->node.field_ref.sm_field_ref,
				expr->node.field_ref.struct_ref);
    }
    if (expr->node_type != ecl_field) return 0;
    assert(strct != NULL);
    strct = get_complex_type(0, strct);	
    assert(strct->node_type == ecl_struct_type_decl);
    fields =  strct->node.struct_type_decl.fields;
    while(fields != NULL) {
	if (fields->node->node.field.sm_var_control_field == expr) return 1;
	fields = fields->next;
    }
    return 0;
}


static int 
is_array(sm_ref expr)
{
    if (expr->node_type == ecl_field_ref) {
	return is_array(expr->node.field_ref.sm_field_ref);
    }
    if (expr->node_type == ecl_element_ref) {
	return is_n_dimen_array(2, expr->node.element_ref.array_ref);
    }
    if (expr->node_type != ecl_field) return 0;
    if (expr->node.field.sm_var_control_field != NULL) return 1;

    if ((expr->node.field.dimen1 == 1) &&
	(expr->node.field.dimen2 == 1)) return 0;
    return 1;
}
    
static int semanticize_expr(ecl_parse_context context, sm_ref expr, 
			    scope_ptr scope) 
{
    switch(expr->node_type) {
    case ecl_identifier: {
	sm_ref tmp = resolve(expr->node.identifier.id, scope);
	if (tmp != NULL) {
	    expr->node.identifier.sm_declaration = tmp;
	    return 1;
	} else {
	    ecl_src_error(context, expr,
			  "Undefined Symbol \"%s\"", 
			  expr->node.identifier.id);
	    return 0;
	}
    }
    case ecl_cast: {
	if (!semanticize_expr(context, expr->node.cast.expression, scope)) {
	    return 0;
	}
	expr->node.cast.cg_type = 
	    reduce_type_list(context, expr->node.cast.type_spec);
	if (expr->node.cast.cg_type == DR_ERR) {
	    return 0;
	}
	return 1;
    }
    case ecl_operator: {
	int ret = 1;
	if (expr->node.operator.left != NULL) {
	    if (!semanticize_expr(context, expr->node.operator.left, scope)) {
		ret = 0;
	    }
	}
	if (!semanticize_expr(context, expr->node.operator.right, scope)) {
	    ret = 0;
	}
	if (ret == 0) return 0;
	if (expr->node.operator.left != NULL) {
	    expr->node.operator.operation_type = 
		determine_op_type(context, expr, 
				  ecl_sm_get_type(expr->node.operator.left),
				  ecl_sm_get_type(expr->node.operator.right));
	    if (expr->node.operator.operation_type == DR_ERR) {
		return 0;
	    }
	} else {
	    expr->node.operator.operation_type = ecl_sm_get_type(expr->node.operator.right);
	}
	switch (expr->node.operator.op) {
	case op_leq: case op_lt: case op_geq: case op_gt: case op_neq: 
	case op_log_neg: case op_log_or: case op_log_and:
	    expr->node.operator.result_type = DR_I;
	    break;
	default:
	    expr->node.operator.result_type=expr->node.operator.operation_type;
	}
	return ret;
    }
    case ecl_constant:
	return 1;
    case ecl_assignment_expression: {
	int ret = 1;
	if (!semanticize_expr(context, expr->node.assignment_expression.left, scope)) {
	    ret = 0;
	} else {
	    expr->node.assignment_expression.cg_type = 
		ecl_sm_get_type(expr->node.assignment_expression.left);
	}
	if (expr->node.assignment_expression.cg_type == DR_P) {
	    if (!is_string(expr->node.assignment_expression.left)) {
		ecl_src_error(context, expr->node.assignment_expression.left, "Invalid assignment, left side must be simple, non-pointer type");
		ret = 0;
	    }
	}
	if (!semanticize_expr(context, expr->node.assignment_expression.right, scope)){
	    ret = 0;
	} else {
	    int right_type = 
		ecl_sm_get_type(expr->node.assignment_expression.right);
	    if ((right_type == DR_P) && 
		(is_string(expr->node.assignment_expression.right))) {
		if (expr->node.assignment_expression.cg_type != DR_P) {
		    ecl_src_error(context, expr, "assignment mixes string and non-string types");
		    ret = 0;
		}
	    } else if ((right_type == DR_B) || (right_type == DR_ERR)) {
		ecl_src_error(context, expr->node.assignment_expression.right, "Invalid assignment, right side must be simple type");
		ret = 0;
	    }
	}
	return ret;
    }
    case ecl_field_ref: {
	sm_ref typ;
	sm_list fields;
	if (!semanticize_expr(context, expr->node.field_ref.struct_ref, scope)) {
	    return 0;
	}
	typ = get_complex_type(context, expr->node.field_ref.struct_ref);
	if (typ == NULL) {
	    ecl_src_error(context, expr->node.field_ref.struct_ref, 
			  "Reference must be structured type", 
			  expr->node.field_ref.lx_field);
	    return 0;
	}
	fields =  typ->node.struct_type_decl.fields;
	while(fields != NULL) {
	    if (strcmp(expr->node.field_ref.lx_field,
		       fields->node->node.field.name) == 0) {
		break;
	    }
	    fields = fields->next;
	}
	if (fields == NULL) {
	    ecl_src_error(context, expr, 
			  "Unknown field reference, \"%s\".",
			  expr->node.field_ref.lx_field);
	    return 0;
	}
	expr->node.field_ref.sm_field_ref = fields->node;
	return 1;
    }
    case ecl_element_ref: {
	if (semanticize_expr(context, expr->node.element_ref.array_ref, scope)) {
	    int cg_type;
	    if (!is_array(expr->node.element_ref.array_ref)) {
		ecl_src_error(context, expr, "Indexed element must be array");
		return 0;
	    }
	    if (!semanticize_expr(context, expr->node.element_ref.expression, scope)) {
		return 0;
	    }
	    
	    cg_type = ecl_sm_get_type(expr->node.element_ref.expression);
	    switch(cg_type) {
	    case DR_C:
	    case DR_UC:
	    case DR_S:
	    case DR_US:
	    case DR_I: 
	    case DR_U: 
	    case DR_L:
	    case DR_UL:
		return 1;
		break;
	    }
	    ecl_src_error(context, expr, 
			  "Index for element reference must be integer type");
	    return 0;
	}
	return 0;
    }
    case ecl_subroutine_call: {
	sm_ref func_ref = expr->node.subroutine_call.sm_func_ref;
	sm_ref tmp = resolve(func_ref->node.identifier.id, scope);
	sm_list args = expr->node.subroutine_call.arguments;
	sm_list formals;
	int ret = 1;
	if (tmp != NULL) {
	    if ((tmp->node_type != ecl_declaration) ||
		!tmp->node.declaration.is_subroutine) {
		ecl_src_error(context, expr, 
			      "Identifier is not subroutine \"%s\".", 
			func_ref->node.identifier.id);
		return 0;
	    }
	    free(func_ref->node.identifier.id);
	    free(func_ref);
	    expr->node.subroutine_call.sm_func_ref = func_ref = tmp;
	    formals = func_ref->node.declaration.params;
	} else {
	    ecl_src_error(context, func_ref, "Undefined Subroutine \"%s\".", 
			  func_ref->node.identifier.id);

	    return 0;
	}
	while (args != NULL) {
	    sm_ref arg = args->node;
	    sm_ref formal = NULL;
	    if (formals != NULL) {
		formal = formals->node;
	    }
	    if (!semanticize_expr(context, arg, scope) ) {
		args = args->next;
		continue;
	    }
	    if (formal == NULL) {
		ecl_src_error(context, arg, "To many arguments to subroutine");
		ret = 0;
		return ret;
	    }
	    if (strcmp(formal->node.declaration.id, "...") != 0) {
		/* we've got a real formal to check against */
		/* do some checking... */
		int mismatch = 0;
		switch (ecl_sm_get_type(arg)) {
		case DR_D: case DR_F:
		    if ((formal->node.declaration.cg_type != DR_D) &&
			(formal->node.declaration.cg_type != DR_F)) {
			mismatch++;
		    }
		    break;
		case DR_I: case DR_U:
		case DR_L: case DR_UL:
		    if ((formal->node.declaration.cg_type == DR_D) ||
			(formal->node.declaration.cg_type == DR_F) ||
			(formal->node.declaration.cg_type == DR_P)) {
			mismatch++;
		    }
		    break;
		case DR_P:
		    if (formal->node.declaration.cg_type != DR_P) mismatch++;
		    break;
		}

		if (mismatch) {
		    ecl_src_error(context, arg, 
				  "Type mismatch, parameter \"%s\".",
			    formal->node.declaration.id);
		    ret = 0;
		}
	    }
	    args = args->next;
	    if ((formals != NULL) &&
		(strcmp(formal->node.declaration.id, "...") != 0)) {
		formals = formals->next;
	    }
	}
	return ret;
    }
    default:
	fprintf(stderr, "Unknown case in semanticize_expression\n");
	ecl_print(expr);
    }
    return 0;
}

extern int
ecl_sm_get_type(sm_ref node)
{
    switch(node->node_type) {
    case ecl_identifier:
	if (node->node.identifier.sm_declaration != NULL) {
	    return ecl_sm_get_type(node->node.identifier.sm_declaration);
	}
	return node->node.identifier.cg_type;
    case ecl_operator:
	return node->node.operator.result_type;
    case ecl_cast:
	return node->node.cast.cg_type;
    case ecl_assignment_expression:
	return node->node.assignment_expression.cg_type;
    case ecl_declaration:
	return node->node.declaration.cg_type;
    case ecl_constant:
	/* need to handle bigger constants */
	if (node->node.constant.token == string_constant) {
	    return DR_P;
	} else if (node->node.constant.token == floating_constant) {
	    return DR_F;
	} else {
	    return DR_I;
	}
    case ecl_field_ref:
	return ecl_sm_get_type(node->node.field_ref.sm_field_ref);
    case ecl_element_ref:
    {
	sm_ref array = node->node.element_ref.array_ref;
	if (!is_array(array)) return DR_ERR;
	if (array->node_type == ecl_field_ref) {
	    array = array->node.field_ref.sm_field_ref;
	}
	if (array->node_type == ecl_field) {
	    /* single dimen reference */
	    if ((array->node.field.sm_var_control_field != 0) ||
		(array->node.field.dimen2 == 1)) {
		return array->node.field.cg_type;
	    } else {
		/* must be multi dimen array */
		return DR_P;
	    }
	} else if (array->node_type == ecl_element_ref) {
	    /* multi dimen reference */
	    sm_ref array2 = array->node.element_ref.array_ref;
	    if (array2->node_type == ecl_field_ref) {
		array2 = array2->node.field_ref.sm_field_ref;
	    }
	    if (array2->node_type != ecl_field) return DR_ERR;
	    if ((array2->node.field.sm_var_control_field != 0) ||
		(array2->node.field.dimen2 == 1)) {
		return DR_ERR;  /* too many dimen reference */
	    }
	    return array2->node.field.cg_type;
	} else {
	    return DR_ERR;
	}
	break;
    }
/*	return ecl_sm_get_type(node->node.element_ref.array_ref);*/
    case ecl_field:
	if (is_array(node)) {
	    return DR_P;
	} else {
	    return node->node.field.cg_type;
	}
    case ecl_subroutine_call:
	return ecl_sm_get_type(node->node.subroutine_call.sm_func_ref);
    default:
	fprintf(stderr, "Unknown case in ecl_sm_get_type()\n");
	ecl_print(node);
    }
    return DR_ERR;
}

static sm_ref
get_complex_type(ecl_parse_context context, sm_ref node)
{
    switch(node->node_type) {
    case ecl_identifier:
	return get_complex_type(context, 
				node->node.identifier.sm_declaration);
    case ecl_element_ref:
    {
	sm_ref array = node->node.element_ref.array_ref;
	return get_complex_type(context, array->node.field_ref.sm_field_ref);
    }
    case ecl_field:
	return node->node.field.sm_complex_type;
    case ecl_declaration:
	return node->node.declaration.sm_complex_type;
    case ecl_field_ref:{
	sm_ref typ;
	sm_list fields;
	typ = get_complex_type(context, node->node.field_ref.struct_ref);
	fields =  typ->node.struct_type_decl.fields;
	while ((fields != NULL) && 
	       (strcmp(node->node.field_ref.lx_field,
		       fields->node->node.field.name) != 0)) {
	    fields = fields->next;
	}
	if (fields == NULL) {
	    ecl_src_error(context, node, "Unknown field reference \"%s\".",
		    node->node.field_ref.lx_field);
	    return NULL;
	}
	return fields->node->node.field.sm_complex_type;
    }
    default:
	fprintf(stderr, "Unknown case in get_complex_type()\n");
	ecl_print(node);
    }
    return NULL;
}

static int
reduce_type_list(ecl_parse_context context, sm_list type_list)
{
    sm_list orig_list = type_list;
    int short_appeared = 0;
    int long_appeared = 0;
    int int_appeared = 0;
    int double_appeared = 0;
    int float_appeared = 0;
    int char_appeared = 0;
    int signed_appeared = 0;
    int unsigned_appeared = 0;
    int void_appeared = 0;
    int string_appeared = 0;
    int spec_count = 0;

    if (type_list && type_list->node->node_type != ecl_type_specifier) {
	return DR_ERR;
    }
    while (type_list != NULL) {
	int typ = type_list->node->node.type_specifier.token;
	spec_count++;
	switch (typ) {
	case INT:
	    int_appeared++;
	    break;
	case LONG:
	    long_appeared++;
	    break;
	case SHORT:
	    short_appeared++;
	    break;
	case DOUBLE:
	    double_appeared++;
	    break;
	case STRING:
	    string_appeared++;
	    break;
	case VOID:
	    void_appeared++;
	    break;
	case FLOAT:
	    float_appeared++;
	    break;
	case CHAR:
	    char_appeared++;
	    break;
	case SIGNED:
	    signed_appeared++;
	    break;
	case UNSIGNED:
	    unsigned_appeared++;
	    break;
	}
	type_list = type_list->next;
    }
    if (spec_count == 0) return DR_I;   /* default to int */
    if (void_appeared && (spec_count > 1)) {
	ecl_src_error(context, orig_list->node, 
		      "Void type may not appear with other specifiers");
	return DR_ERR;
    }
    if (string_appeared && (spec_count > 1)) {
	ecl_src_error(context, orig_list->node, 
		      "String type may not appear with other specifiers");
	return DR_ERR;
    }
    if (void_appeared) return DR_V;
    if (string_appeared) return DR_P;
    if (short_appeared + long_appeared > 1) {
	ecl_src_error(context, orig_list->node, 
		      "Only one of long or short permitted");
	return DR_ERR;
    }
    if (short_appeared && (double_appeared + float_appeared)) {
	ecl_src_error(context, orig_list->node, 
		      "Short may not be specified with double or float");
	return DR_ERR;
    }
    if (double_appeared + float_appeared) {
	if (double_appeared + float_appeared + short_appeared + signed_appeared + unsigned_appeared + char_appeared + int_appeared > 1) {
	    ecl_src_error(context, orig_list->node, "Bad type spec");
	    return DR_ERR;
	} else {
	    /* not handling LONG plus one of these */
	    if (double_appeared) {
		return DR_D;
	    } else {
		return DR_F;
	    }
	}
    }

    /* neither float or double appeared */
    if (short_appeared + char_appeared + long_appeared >= 2) {
	ecl_src_error(context, orig_list->node, 
		      "Only one integer size spec may be specified");
	return DR_ERR;
    }
    if (unsigned_appeared + signed_appeared > 1) {
	ecl_src_error(context, orig_list->node, "Bad type spec");
	return DR_ERR;
    }
    if (unsigned_appeared) {
	if (char_appeared) {
	    return DR_UC;
	} else if (short_appeared) {
	    return DR_US;
	} else if (long_appeared) {
	    return DR_UL;
	} else {
	    return DR_U;
	}
    } else {
	if (char_appeared) {
	    return DR_C;
	} else if (short_appeared) {
	    return DR_S;
	} else if (long_appeared) {
	    return DR_L;
	} else {
	    return DR_I;
	}
    }
}

static int semanticize_type_node(ecl_parse_context context, sm_ref decl, 
				 scope_ptr scope);

static int semanticize_decl(ecl_parse_context context, sm_ref decl, 
			    scope_ptr scope)
{
    switch(decl->node_type) {
    case ecl_declaration: 
	if (resolve_local(decl->node.declaration.id, scope) != NULL) {
	    ecl_src_error(context, decl, "Duplicate Symbol \"%s\"", 
		    decl->node.declaration.id);
	    return 0;
	} else {
	    add_decl(decl->node.declaration.id, decl, scope);
	}
	if (scope->containing_scope == NULL) {
	    /* must be external variable */
	    void *extern_value = 
		resolve_extern(decl->node.declaration.id, scope);
	    if (extern_value == NULL) {
		ecl_src_error(context, decl, 
			      "External symbol lacking address \"%s\"", 
			decl->node.declaration.id);
		return  0;
	    }
	    decl->node.declaration.cg_address = extern_value;
	}
	if (decl->node.declaration.static_var) {
	    if (decl->node.declaration.init_value != NULL) {
		sm_ref const_val = decl->node.declaration.init_value;
		if (const_val->node_type != ecl_constant) {
		    ecl_src_error(context, const_val, 
				  "Only simple constants allowed as static initializers.  Variable \"%s\"",
			decl->node.declaration.id);
		    return 0;
		}
	    }
	}
	decl->node.declaration.cg_type = 
	    reduce_type_list(context, decl->node.declaration.type_spec);
	if (decl->node.declaration.cg_type == DR_ERR) {
	    if (decl->node.declaration.type_spec->node->node_type == ecl_identifier) {
		decl->node.declaration.sm_complex_type = find_complex_type(decl->node.declaration.type_spec->node, scope);
		decl->node.declaration.cg_type = DR_P;
	    } else {
		return 0;
	    }
	} else {
	    decl->node.declaration.sm_complex_type = NULL;
	}
	if (decl->node.declaration.init_value != NULL) {
	    return semanticize_expr(context, decl->node.declaration.init_value, 
				    scope);
	}
	if (decl->node.declaration.is_subroutine) {
	    int ret;
	    scope_ptr sub_scope = push_scope(scope);
	    ret = semanticize_decls_list(context,
					 decl->node.declaration.params, 
					 sub_scope);
	    pop_scope(sub_scope);
	    return ret;
	}
	return 1;
	break;
    case ecl_struct_type_decl:
	return semanticize_type_node(context, decl, scope);
	break;
    default:
	printf("Unhandled case in semantize decls_list\n");
	ecl_print(decl);
    }
    return 0;
}

static int
semanticize_decls_list(ecl_parse_context context, sm_list decls, 
		       scope_ptr scope)
{
    int ret = 1;
    while (decls != NULL) {
	if (!semanticize_decl(context, decls->node, scope)) {
	    ret = 0;
	}
	decls = decls->next;
    }
    return ret;
}

static int semanticize_statement(ecl_parse_context context, sm_ref stmt, 
				 scope_ptr scope);

static int
semanticize_selection_statement(ecl_parse_context context, sm_ref selection,
				scope_ptr scope)
{
    int ret = 1;
    if (!semanticize_expr(context, 
			  selection->node.selection_statement.conditional,
			  scope)) {
	ret = 0;
    }
    if (!semanticize_statement(context,
			       selection->node.selection_statement.then_part,
			       scope)) {
	ret = 0;
    }
    if (selection->node.selection_statement.else_part) {
	if (!semanticize_statement(context,
				   selection->node.selection_statement.else_part,
				   scope)) {
	    ret = 0;
	}
    }
    return ret;
}

static int
semanticize_iteration_statement(ecl_parse_context context, sm_ref iteration,
				scope_ptr scope)
{
    int ret = 1;
    if (iteration->node.iteration_statement.init_expr != NULL) {
	if (!semanticize_expr(context, 
			      iteration->node.iteration_statement.init_expr,
			      scope)) {
	    ret = 0;
	}
    }

    if (iteration->node.iteration_statement.test_expr != NULL) {
	if (!semanticize_expr(context, 
			      iteration->node.iteration_statement.test_expr,
			      scope)) {
	    ret = 0;
	}
    }

    if (iteration->node.iteration_statement.iter_expr != NULL) {
	if (!semanticize_expr(context, 
			      iteration->node.iteration_statement.iter_expr,
			      scope)) {
	    ret = 0;
	}
    }

    if (iteration->node.iteration_statement.statement != NULL) {
	if (!semanticize_statement(context,
				   iteration->node.iteration_statement.statement,
				   scope)) {
	    ret = 0;
	}
    }
    return ret;
}

static int 
semanticize_statement(ecl_parse_context context, sm_ref stmt, 
		      scope_ptr scope)
{
    switch (stmt->node_type) {
    case ecl_selection_statement:
	return semanticize_selection_statement(context, stmt, scope);
    case ecl_iteration_statement:
	return semanticize_iteration_statement(context, stmt, scope);
    case ecl_expression_statement: {
	return semanticize_expr(context, 
				stmt->node.expression_statement.expression,
				scope);
    }	
    case ecl_compound_statement:
	return semanticize_compound_statement(context, stmt, scope);
    case ecl_return_statement:{
	stmt->node.return_statement.cg_func_type = context->return_cg_type;
	return semanticize_expr(context, 
				stmt->node.return_statement.expression,
				scope);
    }	
    default:
	printf("unhandled case1\n");
	return 1;
    }
}

static int
semanticize_statements(ecl_parse_context context, sm_list stmts, 
		       scope_ptr scope)
{
    int ret = 1;
    while (stmts != NULL) {
	if (!semanticize_statement(context, stmts->node, scope)) {
	    ret = 0;
	}
	stmts = stmts->next;
    }
    return ret;
}

extern int
semanticize_compound_statement(ecl_parse_context context, sm_ref compound, 
			       scope_ptr containing_scope)
{
    int ret = 1;
    scope_ptr current_scope = push_scope(containing_scope);
    ret &= semanticize_decls_list(context,
				  compound->node.compound_statement.decls,
				  current_scope);
    ret &= semanticize_statements(context,
				  compound->node.compound_statement.statements,
				  current_scope);
    pop_scope(current_scope);
    return ret;
}

extern sm_ref
ecl_build_type_node(const char *name, IOFieldList field_list)
{
    sm_ref decl = ecl_new_struct_type_decl();
    sm_list *end_ptr = &decl->node.struct_type_decl.fields;

    decl->node.struct_type_decl.id = strdup(name);
    while ((field_list != NULL) && (field_list->field_name != NULL)) {
	sm_list new_elem;
	new_elem = malloc(sizeof(*new_elem));
	new_elem->next = NULL;
	new_elem->node = ecl_new_field();
	new_elem->node->node.field.name = strdup(field_list->field_name);
	new_elem->node->node.field.string_type = strdup(field_list->field_type);
	new_elem->node->node.field.cg_size = field_list->field_size;
	new_elem->node->node.field.cg_offset = field_list->field_offset;
	new_elem->node->node.field.cg_type = DR_ERR;
	*end_ptr = new_elem;
	end_ptr = &new_elem->next;
	field_list++;
    }
    return decl;
}


static
void
add_defined_type(id, context)
char *id;
ecl_parse_context context;
{
    int count = context->defined_type_count;
    if (count == 0) {
	context->defined_types = malloc(sizeof(char*));
    } else {
	context->defined_types = realloc(context->defined_types,
					 (count+1)*sizeof(char*));
    }
    context->defined_types[count] = id;
    context->defined_type_count++;
}

extern void
ecl_add_struct_type(const char *name, IOFieldList field_list, 
		    ecl_parse_context context)
{
    sm_ref node = ecl_build_type_node(name, field_list);
    add_defined_type(name, context);
    ecl_add_decl_to_parse_context(name, node, context);
}

static int
str_to_data_type(str, size)
char *str;
int size;
{
    char *tmp = malloc(strlen(str) + 1);
    strcpy(tmp, str);
    str = tmp;			/* make a copy of str parameter */

    while (isspace((int)*str)) {	/* skip preceeding space */
	str++;
    }
    tmp = str + strlen(str) - 1;
    while (isspace((int)*tmp)) {	/* kill trailing space */
	*tmp = 0;
	tmp--;
    }
    tmp = str;
    while (*tmp) {		/* map to lower case */
	*tmp = tolower(*tmp);
	tmp++;
    }
    if ((strcmp(str, "integer") == 0) || (strcmp(str, "enumeration") == 0)) {
	free(str);
	if (size == sizeof(long)) {
	    return DR_L;
	} else if (size == sizeof(int)) {
	    return DR_I;
	} else if (size == sizeof(short)) {
	    return DR_S;
	} else if (size == sizeof(char)) {
	    return DR_C;
	} else {
	    fprintf(stderr, "unsupported integer size %d\n", size);
	    return DR_I;
	}
    } else if (strcmp(str, "unsigned integer") == 0) {
	free(str);
	if (size == sizeof(long)) {
	    return DR_UL;
	} else if (size == sizeof(int)) {
	    return DR_U;
	} else if (size == sizeof(short)) {
	    return DR_US;
	} else if (size == sizeof(char)) {
	    return DR_UC;
	} else {
	    fprintf(stderr, "unsupported unsigned integer size %d\n", size);
	    return DR_I;
	}
    } else if ((strcmp(str, "float") == 0) || (strcmp(str, "double") == 0)) {
	free(str);
	if (size == sizeof(double)) {
	    return DR_D;
	} else if (size == sizeof(float)) {
	    return DR_F;
	} else {
	    fprintf(stderr, "unsupported float size %d\n", size);
	    return DR_D;
	}
    } else if (strcmp(str, "char") == 0) {
	free(str);
	assert(size == 1);
	return DR_C;
    } else if (strcmp(str, "string") == 0) {
	free(str);
	assert(size == sizeof(char*));
	return DR_P;
    } else {
	free(str);
	return DR_ERR;
    }
}

static int
array_str_to_data_type(str, size, dimen1_ptr, dimen2_ptr)
char *str;
int size;
int *dimen1_ptr;
int *dimen2_ptr;
{
    int ret_type;
    char field_type[1024];
    char *left_paren;
    if ((left_paren = strchr(str, '[')) == NULL) {
	*dimen1_ptr = *dimen2_ptr = 1;
	ret_type = str_to_data_type(str, size);
    } else if (strchr(left_paren + 1, '[') == NULL) {
	/* single dimen array */
	int dimension = 0;
	int i = 0;
	char *tmp = str;
	for( ; tmp < left_paren; tmp++) {
	    field_type[i++] = *tmp;
	}
	field_type[i] = 0;
	if (sscanf(left_paren + 1, "%d]", &dimension) != 1) {
	    ret_type = str_to_data_type(field_type, size);
	    *dimen1_ptr = -1;
	    *dimen2_ptr = 1;
	} else {
	    ret_type = str_to_data_type(field_type, size);
	    *dimen1_ptr = dimension;
	    *dimen2_ptr = 1;
	}
    } else {
	/* double dimen array */
	int dimension1 = 0;
	int dimension2 = 0;
	int i = 0;
	char *tmp = str;
	for( ; tmp < left_paren; tmp++) {
	    field_type[i++] = *tmp;
	}
	field_type[i] = 0;
	if (sscanf(left_paren + 1, "%d][%d]", &dimension1, &dimension2) != 2) {
	    fprintf(stderr, "Couldn't parse array size in \"%s\"\n", str);
	    *dimen1_ptr = 0;
	    *dimen2_ptr = 0;
	    ret_type = str_to_data_type(field_type, size);
	} else {
	    ret_type = str_to_data_type(field_type, size);
	    *dimen1_ptr = dimension1;
	    *dimen2_ptr = dimension2;
	}
    }
    return ret_type;
}

static int
is_var_array(context, decl, f, fields, err)
ecl_parse_context context;
sm_ref decl;
sm_ref f;
sm_list fields;
int *err;
{
    char field_name[1024];
    char *left_paren;
    int junk;
    char *str = f->node.field.string_type;

    *err = 0;
    if ((left_paren = strchr(str, '[')) == NULL) {
	return 0;
    } else if (strchr(left_paren + 1, '[') == NULL) {
	/* single dimen array */

	if (sscanf(left_paren + 1, "%d]", &junk) != 1) {
	    int count = 0;
	    int i = 0;
	    while (((left_paren+1)[count] != ']') &&
		   ((left_paren+1)[count] != 0)) {
		field_name[count] = (left_paren+1)[count];
		count++;
	    }
	    field_name[count] = 0;
	    while(fields != NULL) {
		if (strcmp(field_name, fields->node->node.field.name) == 0) {
		    switch (str_to_data_type(fields->node->node.field.string_type, (int)sizeof(int))) {
		    case DR_C: case DR_UC: case DR_S: case DR_US: 
		    case DR_I: case DR_U: case DR_L: case DR_UL:
			f->node.field.sm_var_control_field = fields->node;
			return 1;
			break;
		    default:
			ecl_src_error(context, decl, 
				      "Variable length control field \"%s\"not of integer type.", field_name);
			*err = 1;
			return 0;
			break;
		    }
		}
		i++;
		fields = fields->next;
	    }
	    ecl_src_error(context, decl, 
			  "Variable length control field \"%s\" not found.", field_name);
	    *err = 1;
	    return 0;
	} else {
	    return 0;
	}
    }
    return 0;
}

#define Max(i,j) ((i<j) ? j : i)

static int
semanticize_type_node(ecl_parse_context context, sm_ref decl, 
		      scope_ptr scope)
{
    int ret = 1;
    int struct_size = 0;
    sm_list fields = decl->node.struct_type_decl.fields;
    add_decl(decl->node.struct_type_decl.id, decl, scope);
    while(fields != NULL) {
	field *f = &fields->node->node.field;
	int field_size = 0;
	int err;

	if (is_var_array(context, decl, fields->node,
			 decl->node.struct_type_decl.fields, &err)) {
	    field_size = sizeof(char*);
	}
	if (err == 1) ret = 0;
	f->cg_type = array_str_to_data_type(f->string_type, f->cg_size, 
					    &f->dimen1, &f->dimen2);
	f->element_size = f->cg_size;
	if (f->sm_var_control_field == NULL) {
	    field_size = f->dimen1 * f->dimen2 * f->element_size;
	}
	if (f->cg_type == DR_ERR) {
	    char *tmp_str = strdup(f->string_type);
	    char *rbracket = strchr(tmp_str, '[');
	    if (rbracket != NULL) *rbracket = 0;
	    f->sm_complex_type = resolve(tmp_str, scope);
	    if (f->sm_complex_type == NULL) {
		ecl_src_error(context, decl, 
			      "Field \"%s\" has unknown type \"%s\".",
			      f->name, tmp_str);
		ret = 0;
	    }
	    if (rbracket != NULL) *rbracket = '[';
	    free(tmp_str);	    
	}
	assert(field_size > 0);
	struct_size = Max(struct_size,
			  (f->cg_offset + field_size));
	fields = fields->next;
    }
    decl->node.struct_type_decl.cg_size = struct_size;
    return ret;
}

extern sm_ref
ecl_build_param_node(const char *id, sm_ref typ, int param_num)
{
    sm_ref node = ecl_new_declaration();
    sm_ref ident;
    node->node.declaration.param_num = param_num;
    node->node.declaration.id = strdup(id);
    node->node.declaration.sm_complex_type = typ;
    if (typ != NULL) {
	ident = ecl_new_identifier();
	node->node.declaration.type_spec = malloc(sizeof(struct list_struct));
	node->node.declaration.type_spec->next = NULL;
	node->node.declaration.type_spec->node = ident;
	ident->node.identifier.id = strdup(typ->node.struct_type_decl.id);
    }
    return node;
}

extern void
ecl_add_param(const char *id, const char *typ, int param_num, 
	      ecl_parse_context context)
{
    sm_list type_list;
    sm_ref node;
    setup_for_string_parse(typ, context->defined_type_count, context->defined_types);
    parsing_type = 1;
    yyerror_count = 0;
    yycontext = context;
    yyparse();
    parsing_type = 0;
    terminate_string_parse();

    if ((yyparse_value == NULL) || (yyerror_count != 0)) {
	return;
    }
    type_list = (sm_list) yyparse_value;

    node = ecl_build_param_node(id, NULL, param_num);
    node->node.declaration.type_spec = type_list;
    ecl_add_decl_to_parse_context(id, node, context);
}

extern void
ecl_set_return_type(char *typ, ecl_parse_context context)
{
    sm_list type_list;
    setup_for_string_parse(typ, context->defined_type_count, context->defined_types);
    parsing_type = 1;
    yyerror_count = 0;
    yycontext = context;
    yyparse();
    parsing_type = 0;
    terminate_string_parse();

    if ((yyparse_value == NULL) || (yyerror_count != 0)) {
	return;
    }
    type_list = (sm_list) yyparse_value;

    context->return_type_list = type_list;
    context->return_cg_type = reduce_type_list(context, type_list);
}

static sm_ref
find_complex_type(sm_ref node, scope_ptr scope)
{
    assert(node->node_type == ecl_identifier);
    return resolve(node->node.identifier.id, scope);
}

extern ecl_parse_context
new_ecl_parse_context()
{
    ecl_parse_context context = malloc(sizeof(struct parse_struct));
    context->decls = NULL;
    context->scope = push_scope(NULL);
    context->defined_type_count = 0;
    context->defined_types = NULL;
    context->error_func = default_error_out;
    context->client_data = NULL;
    context->return_type_list = NULL;
    context->return_cg_type = DR_I;
    return context;
}

extern void
ecl_free_parse_context(ecl_parse_context parse_context)
{
    pop_scope(parse_context->scope);
    if (parse_context->defined_types) {
	free(parse_context->defined_types);
    }
    if (parse_context->decls) {
	ecl_rfree_list(parse_context->decls, NULL);
    }
    free(parse_context);
}

extern void
ecl_assoc_externs(ecl_parse_context context, ecl_extern_list externs)
{
    context->scope->externs = externs;
}

extern void
ecl_add_decl_to_parse_context(const char *name, sm_ref item, ecl_parse_context context)
{
    sm_list *last_ptr = &context->decls;
    sm_list list = context->decls;
    while (list != NULL) {
	last_ptr = &list->next;
	list = list->next;
    }
    *last_ptr = malloc(sizeof(*list));
    (*last_ptr)->next = NULL;
    (*last_ptr)->node = item;
}
