#ifndef BISON_Y_TAB_H
# define BISON_Y_TAB_H

#ifndef YYSTYPE
typedef union {
    lx_info info;
    int number;
    sm_ref reference;
    sm_list list;
    char *string;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	LPAREN	257
# define	RPAREN	258
# define	LCURLY	259
# define	RCURLY	260
# define	LBRACKET	261
# define	RBRACKET	262
# define	DOT	263
# define	STAR	264
# define	SLASH	265
# define	MODULUS	266
# define	PLUS	267
# define	MINUS	268
# define	LEQ	269
# define	LT	270
# define	GEQ	271
# define	GT	272
# define	EQ	273
# define	NEQ	274
# define	LEFT_SHIFT	275
# define	RIGHT_SHIFT	276
# define	ASSIGN	277
# define	LOG_OR	278
# define	LOG_AND	279
# define	ARITH_OR	280
# define	ARITH_AND	281
# define	ARITH_XOR	282
# define	BANG	283
# define	SEMI	284
# define	IF	285
# define	ELSE	286
# define	FOR	287
# define	CHAR	288
# define	SHORT	289
# define	INT	290
# define	LONG	291
# define	UNSIGNED	292
# define	SIGNED	293
# define	FLOAT	294
# define	DOUBLE	295
# define	VOID	296
# define	STRING	297
# define	STATIC	298
# define	RETURN_TOKEN	299
# define	PRINT	300
# define	COMMA	301
# define	DOTDOTDOT	302
# define	integer_constant	303
# define	string_constant	304
# define	floating_constant	305
# define	identifier_ref	306
# define	type_id	307


extern YYSTYPE yylval;

#endif /* not BISON_Y_TAB_H */
