#ifndef BISON_Y_TAB_H
# define BISON_Y_TAB_H

#ifndef YYSTYPE
typedef union {
    lx_info info;
    int number;
    sm_ref reference;
    sm_list list;
    char *string;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	ARROW	257
# define	LPAREN	258
# define	RPAREN	259
# define	LCURLY	260
# define	RCURLY	261
# define	LBRACKET	262
# define	RBRACKET	263
# define	DOT	264
# define	STAR	265
# define	SLASH	266
# define	MODULUS	267
# define	PLUS	268
# define	MINUS	269
# define	LEQ	270
# define	LT	271
# define	GEQ	272
# define	GT	273
# define	EQ	274
# define	NEQ	275
# define	LEFT_SHIFT	276
# define	RIGHT_SHIFT	277
# define	ASSIGN	278
# define	LOG_OR	279
# define	LOG_AND	280
# define	ARITH_OR	281
# define	ARITH_AND	282
# define	ARITH_XOR	283
# define	BANG	284
# define	SEMI	285
# define	IF	286
# define	ELSE	287
# define	FOR	288
# define	CHAR	289
# define	SHORT	290
# define	INT	291
# define	LONG	292
# define	UNSIGNED	293
# define	SIGNED	294
# define	FLOAT	295
# define	DOUBLE	296
# define	VOID	297
# define	STRING	298
# define	STATIC	299
# define	RETURN_TOKEN	300
# define	PRINT	301
# define	COMMA	302
# define	DOTDOTDOT	303
# define	integer_constant	304
# define	string_constant	305
# define	floating_constant	306
# define	identifier_ref	307
# define	type_id	308


extern YYSTYPE yylval;

#endif /* not BISON_Y_TAB_H */
