typedef struct {
    int line;
    int character;
} srcpos;

typedef struct {
    srcpos lx_srcpos;
    char *string;
} lx_info;

typedef enum {op_modulus, op_plus, op_minus, op_leq, op_lt, op_geq, op_gt, op_eq, op_neq, op_log_neg, op_log_or, op_log_and, op_arith_and, op_arith_or, op_arith_xor, op_left_shift, op_right_shift, op_mult, op_div, op_deref} operator_t;

extern void ecl_print_operator_t(operator_t o);

extern void ecl_print_srcpos(srcpos pos);

extern void *ecl_cg_net(sm_ref net, unsigned int *offset_p,
			ecl_code code_descriptor);
extern int ecl_sm_get_type(sm_ref node);
extern int ecl_expr_is_string(sm_ref expr);
extern int is_control_value(sm_ref expr, sm_ref strct);
extern sm_ref get_complex_type(ecl_parse_context context, sm_ref node);
