#ifndef DOC
#include "config.h"
#include "io.h"
#include "atl.h"
#include "cm.h"
#include "echo.h"

#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef HAVE_WINDOWS_H
#include <windows.h>
#define drand48() (((double)rand())/((double)RAND_MAX))
#define lrand48() rand()
#endif
#endif
int main(argc, argv)
int argc;
char **argv;
{
    CManager cm;
    EChannel chan;
    EControlContext cc;
    ECSourceHandle handle;
    long a = time(NULL) % 100;

    cm = CManager_create();
    cc = ECho_CM_init(cm);

    chan = EChannel_open(cc, argv[1]);
    handle = ECsource_subscribe(chan);
    while (1) {
	printf("I'm submitting %ld\n", ++a);
	ECsubmit_event(handle, &a, sizeof(a));
	CMsleep(cm, 5);
    }
}
