#ifndef _AVG_H
#define _AVG_H

#define AVG_EXP_1	1981
#define AVG_FSHIFT	11		/*nr of bits of precision */
#define AVG_FIXED_1	(1<<AVG_FSHIFT)	/* 1.0 as fixed-point */
#define AVG_FREQ	(2*HZ)	/* 2 sec intervals */

#define CALC_AVG(load,exp,n) 	\
	load *= exp; 			\
	load += n*(AVG_FIXED_1-exp);\
	load >>= AVG_FSHIFT;

#define LOAD_INT(x)	((x) >> FSHIFT)
#define LOAD_FRAC(x)	LOAD_INT(((x) & (AVG_FIXED_1-1)) * 100)



#endif	// _AVG_H
