
#ifndef KECHO
#define KECHO
#endif

#include "config.h"
#include "../../include/io.h"
#include "../../include/atl.h"
#include "../../include/cm.h"
#include "../../include/echo.h"
#include "../../include/comm_group2.h"

#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#define APP_NAME "TEST1"
#define GRP_TYPE "TEST1"

struct test_struct {
  int type;
  char hostname[64];
  int v1;
  int v2;
  int v3;
  int v4;
  int v5;
  int v6;
  int v7;
};

void handler(void *event, int length, void *client_data, attr_list event_attrs)
{
 struct test_struct test;
 memcpy(&test, event, length); 
printf("Event received(%d)!!\n", test.type);
//    printf("Event read:%ld\n", *(long *)event);
//    if (event_attrs != NULL) printf("Attributes received\n");
}

int main(int argc, char *argv[])
{
    EChannel uchan;
    CManager ucm;
    EControlContext ucc;
    ECSinkHandle shandle;
    int i;
    comm_group_return groups;

printf("phase1\n");
    ucm = CManager_create();
printf("phase2\n");
    ucc = ECho_CM_init(ucm);

printf("phase3\n");
    groups = matching_comm_groups(APP_NAME, GRP_TYPE);

printf("phase5\n");
    uchan = EChannel_open(ucc, groups->list[0].info);

printf("phase6a\n");
//    uhandle = ECsource_subscribe(uchan);

printf("phase6\n");
    shandle = ECsink_subscribe(uchan, handler, NULL);

    for (i = 0; i < 20; i++) {
printf("poll(%d)\n", i);
	CMpoll_network(ucm);
//ECsubmit_event(uhandle, &b, sizeof(long));
	sleep(1);
    }

    printf("reader done...\n"); 
    return 1;
}

