#include <assert.h>
#include <stdio.h>
#include "drisc.h"

int main() { 
	dr_reg_t r;
	drisc_ctx c = dr_init();
	drisc_ctx static_ctx = c;
	void (*vp)();

	dr_clambda(c, "foo");
	dr_getreg(c, &r, DR_I, DR_TEMP);

	dr_push_init(c);
	dr_push_argpi(c, "Hello: %d %d %d %d\n");
	dr_seti(c, r, 10);
	dr_push_argi(c, r);
	dr_seti(c, r,20);
	dr_push_argi(c, r);
	dr_seti(c, r,30);
	dr_push_argi(c, r);
	dr_seti(c, r,40);
	dr_push_argi(c, r);
	dr_ccallv(c, (void*)printf);
	vp = (void (*)())dr_end(c);
#if 0
	dr_dump((void*)vp);
#endif
	vp();

	dr_clambda(c, "foo");
	dr_push_init(c);
	dr_push_argpi(c, "Hello: %d %d %d %d\n");
	dr_push_argii(c, 10);
	dr_push_argii(c, 20);
	dr_push_argii(c, 30);
	dr_push_argii(c, 40);
	dr_ccallv(c, (void*)printf);
	vp = (void (*)()) dr_end(c);
#if 0
	dr_dump((void*)vp);
#endif
	vp();

	dr_clambda(c, "foo");
	dr_push_init(c);
	dr_push_argpi(c, "Hello: %d %d %d %d %d %d %d %d %d %d\n");
	dr_push_argii(c, 10);
	dr_push_argii(c, 20);
	dr_push_argii(c, 30);
	dr_push_argii(c, 40);
	dr_push_argii(c, 50);
	dr_push_argii(c, 60);
	dr_push_argii(c, 70);
	dr_push_argii(c, 80);
	dr_push_argii(c, 90);
	dr_push_argii(c, 100);
	dr_ccallv(c, (void*)printf);
	vp = (void (*)())dr_end(c);
#if 0
	dr_dump((void*)vp);
#endif
	vp();

	dr_clambda(c, "foo");
	dr_push_init(c);
	dr_push_argpi(c, "Hello: %e %e %e %e %e %e %e %e %e %e\n");
	dr_push_argdi(c, 10.0);
	dr_push_argdi(c, 20.0);
	dr_push_argdi(c, 30.0);
	dr_push_argdi(c, 40.0);
	dr_push_argdi(c, 50.0);
	dr_push_argdi(c, 60.0);
	dr_push_argdi(c, 70.0);
	dr_push_argdi(c, 80.0);
	dr_push_argdi(c, 90.0);
	dr_push_argdi(c, 100.0);
	dr_ccallv(c, (void*)printf);
	vp = (void (*)())dr_end(c);
#if 0
	dr_dump((void*)vp);
#endif
	vp();

#if 0
	dr_clambda("foo", V_NLEAF, insn, sizeof insn);
	dr_push_argpi(c, "Hello: %d %d %d %d\n");
#endif
	return 0;
}
