#include <assert.h>
#include <stdio.h>
#include "drisc.h"

int main() { 
	drisc_ctx c = dr_init();
	int (*ip)();

        /* jal reg  */
        dr_clambda(c, "v_jal");
        {
        	static void * linked_addr;
        	dr_reg_t rdp;
        	dr_reg_t rr;
        	dr_reg_t v_zero;
		int l;

		dr_getreg(c, &rdp, DR_P, DR_VAR);
		dr_getreg(c, &rr, DR_P, DR_VAR);
		dr_getreg(c, &v_zero, DR_P, DR_VAR);

                l = dr_genlabel(c);
                dr_dmark(c, &linked_addr, l);

		dr_setp(c, v_zero, 0);
                dr_ldpi(c, rdp, v_zero, (unsigned long)&linked_addr);
		dr_scallv(c, (void*)printf, "%P", "Jumping!\n");
                dr_jalp(c, rr, rdp);
		dr_scallv(c, (void*)printf, "%P", "Returning.\n");	
               	dr_retii(c, 13);

                dr_label(c, l);
			dr_scallv(c, (void*)printf, "%P", "Jumping back!\n");
			dr_jp(c, rr);
        }
	printf("Testing jalr\n");
	ip = (int (*)())dr_end(c);
#if 0
	dr_dump(c);
#endif
        if(ip() != 13) {
	    printf("jal test failed!\n");
	    dr_dump(c);
	}
	return 0;
}
