/*
 *   kecl.c
 *
 *   Copyright (C) 2002 Christian Poellabauer
 *
 *   Cleanup and modifications by Ivan B. Ganev, 2003
 */

/* 
 *   Kernel-loadable module for event channel support
 */

#include "config.h"

/* Required definitions. */
#ifdef LINUX_KERNEL_MODULE
#ifndef MODULE
#define MODULE
#endif
#ifndef __KERNEL__
#define __KERNEL__
#endif
#endif

/* Various required header files. */
#include <linux/config.h> 
#include <linux/module.h> 
#include <linux/kernel.h> 
#include <linux/init.h> 
#include <linux/types.h> 
#include <linux/tty.h>
#include <linux/unistd.h>
#include <linux/socket.h>
#include <linux/wait.h>
#include <linux/sched.h>
#include <asm/current.h>
#include <asm/semaphore.h>
#include "kecl.h"

MODULE_AUTHOR("Eisenhauer/Poellabauer/Ganev");
MODULE_DESCRIPTION("ECL Module");
MODULE_LICENSE("GPL");

__kernel_ssize_t (*sys_kread) (unsigned int fd, char *buf, size_t count);

/* Initialize module. */
static int __init kecl_init(void) 
{
  return 0;
}

/* Remove module. */
static void __exit kecl_cleanup(void) 
{
}

module_init(kecl_init);
module_exit(kecl_cleanup); 

