#ifndef DOC

#include "config.h"
#include "io.h"
#include "atl.h"
#include "cm.h"
#include "echo.h"

#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef HAVE_WINDOWS_H
#include <windows.h>
#endif
#endif
int main()
{   /* this program creates an event channel */
    EChannel chan;
    CManager cm;
    EControlContext cc;

    cm = CManager_create();
    cc = ECho_CM_init(cm);

    chan = EChannel_create(cc);
    printf("Channel ID is: %s\n", ECglobal_id(chan));
    CMsleep(cm, 600);   /* handle net for 10 min */
    return 1;
}
