/* Definitions. */
#define SKWATCH "sockwatch"

#define SKWATCH_MAX_DC_EVENTS 1024
#define SKWATCH_MAX_UC_EVENTS 1024
#define SKWATCH_DC_ENTRIES (SKWATCH_MAX_DC_EVENTS-1)/32 + 1
#define SKWATCH_UC_ENTRIES (SKWATCH_MAX_UC_EVENTS-1)/32 + 1
#define SKWATCH_DC_EVENT_SIZE 
#define SKWATCH_UC_EVENT_SIZE 
#define SKWATCH_DC_MEMORY sizeof(struct skwatch_dc_data) + \
	sizeof(int) + sizeof(unsigned long) * SKWATCH_DC_ENTRIES
#define SKWATCH_UC_MEMORY sizeof(struct skwatch_uc_data) + \
	sizeof(int) + sizeof(unsigned long) * SKWATCH_UC_ENTRIES

struct skwatch_dc_data {
  int flag;
  unsigned long readable[SKWATCH_DC_ENTRIES];
  unsigned long writable[SKWATCH_DC_ENTRIES];
  unsigned long changes[SKWATCH_DC_ENTRIES];
};

struct skwatch_uc_data {
  int flag;
  unsigned long readable[SKWATCH_UC_ENTRIES];
  unsigned long writable[SKWATCH_UC_ENTRIES];
};

